
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PHP面向对象程序设计之类与反射API详解_php技巧 / iVAN</title>

    <meta name="description" content="PHP面向对象程序设计之类与反射API详解_php技巧 本文实例讲述了PHP面向对象程序设计之类与反射API.分享给大家供大家参考,具体如下: 了解类 class_exists验证类是否存在 &lt;?php // TaskRunner.php $classname = &quot;Task&quot;; $path = &quot;tasks/{$classname}.php&quot;; if ( ! file_exists( $path ) ) { throw new Exception( &quot;No such file as {$pat ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">PHP面向对象程序设计之类与反射API详解_php技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文实例讲述了PHP面向对象程序设计之类与反射API。分享给大家供大家参考，具体如下：</p>
<p><strong>了解类</strong></p>
<p>class_exists验证类是否存在</p>
<pre>
&lt;?php
// TaskRunner.php
$classname = "Task";
$path = "tasks/{$classname}.php";
if ( ! file_exists( $path ) ) {
  throw new Exception( "No such file as {$path}" ); //抛出异常,类文件不存在
}
require_once( $path );
$qclassname = "tasks\\$classname";
if ( ! class_exists( $qclassname ) ) {
  throw new Exception( "No such class as $qclassname" ); //抛出异常,类不存在Fatal error: Uncaught exception 'Exception' with message 'No such class as tasks\Task'
Stack trace:
#0 {main}
}
$myObj = new $qclassname();
$myObj-&gt;doSpeak();
?&gt;
</pre>
<p>get_class 检查对象的类 instanceof 验证对象是否属于某个类</p>
<pre>
&lt;?php
class CdProduct {}
function getProduct() {
  return new CdProduct(  "Exile on Coldharbour Lane",
                "The", "Alabama 3", 10.99, 60.33 ); // 返回一个类对象
}
$product = getProduct();
if ( get_class( $product ) == 'CdProduct' ) {
  print "\$product is a CdProduct object\n";
}
?&gt;
&lt;?php
class CdProduct {}
function getProduct() {
  return new CdProduct(  "Exile on Coldharbour Lane",
                "The", "Alabama 3", 10.99, 60.33 );
}
$product = getProduct();
if ( $product instanceof CdProduct ) {
  print "\$product is a CdProduct object\n";
}
?&gt;
</pre>
<p>get_class_methods 得到类中所有的方法列表,只获取public的方法，protected，private的方法获取不到。默认的就是public。</p>
<pre>
&lt;?php
class CdProduct {
  function __construct() { }
  function getPlayLength() { }
  function getSummaryLine() { }
  function getProducerFirstName() { }
  function getProducerMainName() { }
  function setDiscount() { }
  function getDiscount() { }
  function getTitle() { }
  function getPrice() { }
  function getProducer() { }
}
print_r( get_class_methods( 'CdProduct' ) );
?&gt;
</pre>
<p>output:</p>
<pre>
Array
(
  [0] =&gt; __construct
  [1] =&gt; getPlayLength
  [2] =&gt; getSummaryLine
  [3] =&gt; getProducerFirstName
  [4] =&gt; getProducerMainName
  [5] =&gt; setDiscount
  [6] =&gt; getDiscount
  [7] =&gt; getTitle
  [8] =&gt; getPrice
  [9] =&gt; getProducer
)
</pre>
<p>更多验证</p>
<pre>
&lt;?php
class ShopProduct {}
interface incidental {};
class CdProduct extends ShopProduct implements incidental {
  public $coverUrl;
  function __construct() { }
  function getPlayLength() { }
  function getSummaryLine() { }
  function getProducerFirstName() { }
  function getProducerMainName() { }
  function setDiscount() { }
  function getDiscount() { }
  function getTitle() { return "title\n"; }
  function getPrice() { }
  function getProducer() { }
}
function getProduct() {
  return new CdProduct();
}
$product = getProduct(); // acquire an object
$method = "getTitle";   // define a method name
print $product-&gt;$method(); // invoke the method
if ( in_array( $method, get_class_methods( $product ) ) ) {
  print $product-&gt;$method(); // invoke the method
}
if ( is_callable( array( $product, $method) ) ) {
  print $product-&gt;$method(); // invoke the method
}
if ( method_exists( $product, $method ) ) {
  print $product-&gt;$method(); // invoke the method
}
print_r( get_class_vars( 'CdProduct' ) );
if ( is_subclass_of( $product, 'ShopProduct' ) ) {
  print "CdProduct is a subclass of ShopProduct\n";
}
if ( is_subclass_of( $product, 'incidental' ) ) {
  print "CdProduct is a subclass of incidental\n";
}
if ( in_array( 'incidental', class_implements( $product )) ) {
  print "CdProduct is an interface of incidental\n";
}
?&gt;
</pre>
<p>output:</p>
<pre>
title
title
title
title
Array
(
  [coverUrl] =&gt;
)
CdProduct is a subclass of ShopProduct
CdProduct is a subclass of incidental
CdProduct is an interface of incidental
</pre>
<p>__call方法</p>
<pre>
&lt;?php
class OtherShop {
  function thing() {
    print "thing\n";
  }
  function andAnotherthing() {
    print "another thing\n";
  }
}
class Delegator {
  private $thirdpartyShop;
  function __construct() {
    $this-&gt;thirdpartyShop = new OtherShop();
  }
  function __call( $method, $args ) { // 当调用未命名方法时执行call方法
    if ( method_exists( $this-&gt;thirdpartyShop, $method ) ) {
      return $this-&gt;thirdpartyShop-&gt;$method( );
    }
  }
}
$d = new Delegator();
$d-&gt;thing();
?&gt;
</pre>
<p>output:</p>
<p>thing</p>
<p>传参使用</p>
<pre>
&lt;?php
class OtherShop {
  function thing() {
    print "thing\n";
  }
  function andAnotherthing( $a, $b ) {
    print "another thing ($a, $b)\n";
  }
}
class Delegator {
  private $thirdpartyShop;
  function __construct() {
    $this-&gt;thirdpartyShop = new OtherShop();
  }
  function __call( $method, $args ) {
    if ( method_exists( $this-&gt;thirdpartyShop, $method ) ) {
      return call_user_func_array(
            array( $this-&gt;thirdpartyShop,
              $method ), $args );
    }
  }
}
$d = new Delegator();
$d-&gt;andAnotherThing( "hi", "hello" );
?&gt;
</pre>
<p>output:</p>
<p>another thing (hi, hello)</p>
<p><strong>反射API</strong></p>
<p>fullshop.php</p>
<pre>
&lt;?php
class ShopProduct {
  private $title;
  private $producerMainName;
  private $producerFirstName;
  protected $price;
  private $discount = 0;
  public function __construct(  $title, $firstName,
              $mainName, $price ) {
    $this-&gt;title       = $title;
    $this-&gt;producerFirstName = $firstName;
    $this-&gt;producerMainName = $mainName;
    $this-&gt;price       = $price;
  }
  public function getProducerFirstName() {
    return $this-&gt;producerFirstName;
  }
  public function getProducerMainName() {
    return $this-&gt;producerMainName;
  }
  public function setDiscount( $num ) {
    $this-&gt;discount=$num;
  }
  public function getDiscount() {
    return $this-&gt;discount;
  }
  public function getTitle() {
    return $this-&gt;title;
  }
  public function getPrice() {
    return ($this-&gt;price - $this-&gt;discount);
  }
  public function getProducer() {
    return "{$this-&gt;producerFirstName}".
        " {$this-&gt;producerMainName}";
  }
  public function getSummaryLine() {
    $base = "{$this-&gt;title} ( {$this-&gt;producerMainName}, ";
    $base .= "{$this-&gt;producerFirstName} )";
    return $base;
  }
}
class CdProduct extends ShopProduct {
  private $playLength = 0;
  public function __construct(  $title, $firstName,
              $mainName, $price, $playLength=78 ) {
    parent::__construct(  $title, $firstName,
                $mainName, $price );
    $this-&gt;playLength = $playLength;
  }
  public function getPlayLength() {
    return $this-&gt;playLength;
  }
  public function getSummaryLine() {
    $base = parent::getSummaryLine();
    $base .= ": playing time - {$this-&gt;playLength}";
    return $base;
  }
}
class BookProduct extends ShopProduct {
  private $numPages = 0;
  public function __construct(  $title, $firstName,
              $mainName, $price, $numPages ) {
    parent::__construct(  $title, $firstName,
                $mainName, $price );
    $this-&gt;numPages = $numPages;
  }
  public function getNumberOfPages() {
    return $this-&gt;numPages;
  }
  public function getSummaryLine() {
    $base = parent::getSummaryLine();
    $base .= ": page count - {$this-&gt;numPages}";
    return $base;
  }
  public function getPrice() {
    return $this-&gt;price;
  }
}
/*
$product1 = new CdProduct("cd1", "bob", "bobbleson", 4, 50 );
print $product1-&gt;getSummaryLine()."\n";
$product2 = new BookProduct("book1", "harry", "harrelson", 4, 30 );
print $product2-&gt;getSummaryLine()."\n";
*/
?&gt;
&lt;?php
require_once "fullshop.php";
$prod_class = new ReflectionClass( 'CdProduct' );
Reflection::export( $prod_class );
?&gt;
</pre>
<p>output:</p>
<pre>
Class [ &lt;user&gt; class CdProduct extends ShopProduct ] {
 @@ D:\xampp\htdocs\popp-code\5\fullshop.php 53-73
 - Constants [0] {
 }
 - Static properties [0] {
 }
 - Static methods [0] {
 }
 - Properties [2] {
  Property [ &lt;default&gt; private $playLength ]
  Property [ &lt;default&gt; protected $price ]
 }
 - Methods [10] {
  Method [ &lt;user, overwrites ShopProduct, ctor&gt; public method __construct ] {
   @@ D:\xampp\htdocs\popp-code\5\fullshop.php 56 - 61
   - Parameters [5] {
    Parameter #0 [ &lt;required&gt; $title ]
    Parameter #1 [ &lt;required&gt; $firstName ]
    Parameter #2 [ &lt;required&gt; $mainName ]
    Parameter #3 [ &lt;required&gt; $price ]
    Parameter #4 [ &lt;optional&gt; $playLength = 78 ]
   }
  }
  Method [ &lt;user&gt; public method getPlayLength ] {
   @@ D:\xampp\htdocs\popp-code\5\fullshop.php 63 - 65
  }
  Method [ &lt;user, overwrites ShopProduct, prototype ShopProduct&gt; public method getSummaryLine ] {
   @@ D:\xampp\htdocs\popp-code\5\fullshop.php 67 - 71
  }
  Method [ &lt;user, inherits ShopProduct&gt; public method getProducerFirstName ] {
   @@ D:\xampp\htdocs\popp-code\5\fullshop.php 17 - 19
  }
  Method [ &lt;user, inherits ShopProduct&gt; public method getProducerMainName ] {
   @@ D:\xampp\htdocs\popp-code\5\fullshop.php 21 - 23
  }
  Method [ &lt;user, inherits ShopProduct&gt; public method setDiscount ] {
   @@ D:\xampp\htdocs\popp-code\5\fullshop.php 25 - 27
   - Parameters [1] {
    Parameter #0 [ &lt;required&gt; $num ]
   }
  }
  Method [ &lt;user, inherits ShopProduct&gt; public method getDiscount ] {
   @@ D:\xampp\htdocs\popp-code\5\fullshop.php 29 - 31
  }
  Method [ &lt;user, inherits ShopProduct&gt; public method getTitle ] {
   @@ D:\xampp\htdocs\popp-code\5\fullshop.php 33 - 35
  }
  Method [ &lt;user, inherits ShopProduct&gt; public method getPrice ] {
   @@ D:\xampp\htdocs\popp-code\5\fullshop.php 37 - 39
  }
  Method [ &lt;user, inherits ShopProduct&gt; public method getProducer ] {
   @@ D:\xampp\htdocs\popp-code\5\fullshop.php 41 - 44
  }
 }
}
</pre>
<p>点评：把类看的透彻的一塌糊涂，比var_dump强多了。哪些属性，继承了什么类。类中的方法哪些是自己的，哪些是重写的，哪些是继承的，一目了然。</p>
<p>查看类数据</p>
<pre>
&lt;?php
require_once("fullshop.php");
function classData( ReflectionClass $class ) {
 $details = "";
 $name = $class-&gt;getName();
 if ( $class-&gt;isUserDefined() ) {
  $details .= "$name is user defined\n";
 }
 if ( $class-&gt;isInternal() ) {
  $details .= "$name is built-in\n";
 }
 if ( $class-&gt;isInterface() ) {
  $details .= "$name is interface\n";
 }
 if ( $class-&gt;isAbstract() ) {
  $details .= "$name is an abstract class\n";
 }
 if ( $class-&gt;isFinal() ) {
  $details .= "$name is a final class\n";
 }
 if ( $class-&gt;isInstantiable() ) {
  $details .= "$name can be instantiated\n";
 } else {
  $details .= "$name can not be instantiated\n";
 }
 return $details;
}
$prod_class = new ReflectionClass( 'CdProduct' );
print classData( $prod_class );
?&gt;
</pre>
<p>output:</p>
<p>CdProduct is user defined<br />
CdProduct can be instantiated</p>
<p>查看方法数据</p>
<pre>
&lt;?php
require_once "fullshop.php";
$prod_class = new ReflectionClass( 'CdProduct' );
$methods = $prod_class-&gt;getMethods();
foreach ( $methods as $method ) {
 print methodData( $method );
 print "\n----\n";
}
function methodData( ReflectionMethod $method ) {
 $details = "";
 $name = $method-&gt;getName();
 if ( $method-&gt;isUserDefined() ) {
  $details .= "$name is user defined\n";
 }
 if ( $method-&gt;isInternal() ) {
  $details .= "$name is built-in\n";
 }
 if ( $method-&gt;isAbstract() ) {
  $details .= "$name is abstract\n";
 }
 if ( $method-&gt;isPublic() ) {
  $details .= "$name is public\n";
 }
 if ( $method-&gt;isProtected() ) {
  $details .= "$name is protected\n";
 }
 if ( $method-&gt;isPrivate() ) {
  $details .= "$name is private\n";
 }
 if ( $method-&gt;isStatic() ) {
  $details .= "$name is static\n";
 }
 if ( $method-&gt;isFinal() ) {
  $details .= "$name is final\n";
 }
 if ( $method-&gt;isConstructor() ) {
  $details .= "$name is the constructor\n";
 }
 if ( $method-&gt;returnsReference() ) {
  $details .= "$name returns a reference (as opposed to a value)\n";
 }
 return $details;
}
?&gt;
</pre>
<p>output:</p>
<pre>
__construct is user defined
__construct is public
__construct is the constructor
----
getPlayLength is user defined
getPlayLength is public
----
getSummaryLine is user defined
getSummaryLine is public
----
getProducerFirstName is user defined
getProducerFirstName is public
----
getProducerMainName is user defined
getProducerMainName is public
----
setDiscount is user defined
setDiscount is public
----
getDiscount is user defined
getDiscount is public
----
getTitle is user defined
getTitle is public
----
getPrice is user defined
getPrice is public
----
getProducer is user defined
getProducer is public
</pre>
<p>获取构造函数参数情况</p>
<pre>
&lt;?php
require_once "fullshop.php";
$prod_class = new ReflectionClass( 'CdProduct' );
$method = $prod_class-&gt;getMethod( "__construct" );
$params = $method-&gt;getParameters();
foreach ( $params as $param ) {
  print argData( $param )."\n";
}
function argData( ReflectionParameter $arg ) {
 $details = "";
 $declaringclass = $arg-&gt;getDeclaringClass();
 $name = $arg-&gt;getName();
 $class = $arg-&gt;getClass();
 $position = $arg-&gt;getPosition();
 $details .= "\$$name has position $position\n";
 if ( ! empty( $class ) ) {
  $classname = $class-&gt;getName();
  $details .= "\$$name must be a $classname object\n";
 }
 if ( $arg-&gt;isPassedByReference() ) {
  $details .= "\$$name is passed by reference\n";
 }
 if ( $arg-&gt;isDefaultValueAvailable() ) {
  $def = $arg-&gt;getDefaultValue();
  $details .= "\$$name has default: $def\n";
 }
 if ( $arg-&gt;allowsNull() ) {
  $details .= "\$$name can be null\n";
 }
 return $details;
}
?&gt;
</pre>
<p>output:</p>
<pre>
$title has position 0
$title can be null
$firstName has position 1
$firstName can be null
$mainName has position 2
$mainName can be null
$price has position 3
$price can be null
$playLength has position 4
$playLength has default: 78
$playLength can be null
</pre>
<p>更多关于PHP相关内容感兴趣的读者可查看本站专题：《php面向对象程序设计入门教程》、《PHP基本语法入门教程》、《PHP运算与运算符用法总结》、《PHP网络编程技巧总结》、《PHP数组(Array)操作技巧大全》、《php字符串(string)用法总结》、《php+mysql数据库操作入门教程》及《php常见数据库操作技巧汇总》</p>
<p>希望本文所述对大家PHP程序设计有所帮助。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索php<br />
                    ，                面向对象<br />
                    ，                类<br />
                                    反射API<br />
                                    面向对象 反射、java反射机制详解、java的反射机制详解、java中的反射机制详解、java反射详解，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:45:59</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/php/" title="php">php</a>, <a href="https://www.iamivan.net/tag/%e9%9d%a2%e5%90%91%e5%af%b9%e8%b1%a1/" title="面向对象">面向对象</a>, <a href="https://www.iamivan.net/tag/%e7%b1%bb/" title="类">类</a>, <a href="https://www.iamivan.net/tag/%e5%8f%8d%e5%b0%84api/" title="反射API">反射API</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>PHP面向对象程序设计之类与反射API详解_php技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDk42Op.html" rel="bookmark">PHP Reflection API详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP Reflection API是PHP5才有的新功能,它是用来导出或提取出关于类.方法.属性.参数等的详细信息,包括注释. PHP Reflection API有: class Reflection { } interface Reflector { } class ReflectionException extends Exception { } class ReflectionFunction implements Reflector { } class ReflectionParam			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boO2XBb.html" rel="bookmark">php加速器eAccelerator的配置参数、API详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				它还能够对脚本进行优化以便加速它们的执行速度.利用eAccelerator可以减少服务器的负载并提高PHP代码的执行时间. eAccelerator配置选项: 复制代码 代码如下: zend_extension_ts=&quot;X:Appphp-5.2.13-Win32exteaccelerator.dll&quot;eaccelerator.shm_size=&quot;32″eaccelerator.cache_dir=&quot;X:Appphp-5.2.13-Win32 emp&quot;eac			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxYL8Qp.html" rel="bookmark">PHP基于反射机制实现插件的可插拔设计详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP基于反射机制实现插件的可插拔设计.分享给大家供大家参考,具体如下: 说PHP和ASP等同的朋友们可以就此打住了,PHP支持反射,而且还是非常的强大.好了,我们开始今天的话题. 功能描述: 页面拥有一个主导航菜单,里头有默认连接若干. 插件统一存放在一个目录,插件载入后会自动在导航菜单中增加上自己所需的链接. 插件载入时可执行一定的操作. 动态增删插件无需改动代码. 最终效果: 首页,插件1,插件2 &quot;首页&quot;是系统自带的菜单项.&quot;插件1&quot;和&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXx5wyp.html" rel="bookmark">php禁用函数设置及查看方法详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php禁用函数设置及查看方法.分享给大家供大家参考,具体如下: 打开PHP.INI,找到这行: disable_functions = 在后面那里加上要禁用的函数,如禁用多个函数,要用半角逗号 , 分开 给个例子: 复制代码 代码如下: disable_functions = passthru,exec,system,popen,chroot,scandir,chgrp,chown,escapesh ellcmd,escapeshellarg,shell_exec,proc_ope			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rKB0z.html" rel="bookmark">PHP带节点操作的无限分类实现方法详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP带节点操作的无限分类实现方法.分享给大家供大家参考,具体如下: 包含(移动多个节点:移动单个节点:删除多个节点:删除单个节点:新增节点),另附数据库表结构 一.db sql语句 //db used for php无限分类 create table tree( id int(10) not null primary key auto_increment, name varchar(255) not null, lft int(10) not null default 0, rg			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVDjLkM.html" rel="bookmark">PHP实现的统计数据功能详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP实现的统计数据功能.分享给大家供大家参考,具体如下: 统计,就是把基本的数据,整合起来. 用到sql的,有group by 功能,count功能,order by功能等等. sql将收集的数据,进行统计分析. 一般情况下,sql处理后得到的数据,还要通过php的逻辑来进行整理. 以一定的格式,展示到前台. 一般都是以数组的方式展示,这也是数据结构的概念. 看这张图片,基本想想结构大概为 {上线数,出单总数,核过总数,总人均,总核率,{(坐席人1,工号1,出单数1,发货数1,核			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN8Ad4z.html" rel="bookmark">php实现的操作excel类详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php实现的操作excel类.分享给大家供大家参考,具体如下: &lt;?php class Excel { static $instance=null; private $excel=null; private $workbook=null; private $workbookadd=null; private $worksheet=null; private $worksheetadd=null; private $sheetnum=1; private $cells=array()			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWXgrjp.html" rel="bookmark">php中 &dollar;&dollar;str 中 &amp;quot&semi;&dollar;&dollar;&amp;quot&semi; 的详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这种写法称为可变变量 有时候使用可变变量名是很方便的.就是说,一个变量的变量名可以动态的设置和使用.一个普通的变量通过声明来设置,例如: &lt;?php $a = &quot;hello&quot;; ?&gt; 一个可变变量获取了一个普通变量的值作为这个可变变量的变量名.在上面的例子中 hello 使用了两个美元符号($)以后,就可以作为一个可变变量的变量了.例如: &lt;?php $$a = &quot;world&quot;; ?&gt; 这时,两个变量都被定义了:$a 的内容是&quot;he			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV77KKb.html" rel="bookmark">PHP面向对象程序设计之命名空间与自动加载类详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP面向对象程序设计之命名空间与自动加载类.分享给大家供大家参考,具体如下: 命名空间 避免类名重复,而产生错误. &lt;?php require_once &quot;useful/Outputter.php&quot;; class Outputter { // output data private $name; public function setName($name) { $this-&gt;name = $name; } public function getName()			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkOEpe.html" rel="bookmark" class="title">PostgreSQL 电商小需求 - 凑单商品的筛选</a>
					<div>
						标签 PostgreSQL , 电商 , 凑单 , 最佳凑单 , 任意字段组合 背景 电商的促销活动非常多,规则可能比较复杂,要薅羊毛的话,数学可能要比较好才行.因此也出现了大量的导购网站,比如SMZ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXk6LM.html" rel="bookmark" class="title">回顾08年笔者的N个第一次</a>
					<div>
						笔者进入网络推广这个行业刚好一年了,在这一年里面,有很多的感触.从一个对互联网行业一点都不懂开始学起.在学习的过程中也遇到很多困难.也得到了很多朋友热心帮助.要感谢的人和事很多. 首先要说的是我的师傅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo60Zdz.html" rel="bookmark" class="title">全部窗体可使用鼠标中移动</a>
					<div>
						最简单的办法就是&quot;欺骗&quot;系统,让他认为点中的是窗体的标题行 unit Dragmain; interface uses SysUtils, WinTypes, WinProcs,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBgolb.html" rel="bookmark" class="title">Linux命令之远程登录&sol;无密码登录-ssh&comma;ssh-keygen&comma;ssh-copy-id</a>
					<div>
						SSH是一种安全通道协议,主要用来远程登录.在RHEL 5系统中使用的是OpenSSH服务器由openssh, openssh-server等软件包提供的(默认已经安装),并以将sshd添加为标准的系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jv0Nb.html" rel="bookmark" class="title">局域网中实现linux与Windows文件共享</a>
					<div>
						文件共享是重要的网络需求,特别在企业环境中这种需求显得非常迫切.我们知道Windows主机间的文件共享非常简单,可以通过网上邻居实现.但是企业环境中主机的操作系统比较复杂,其中不乏Linux.Unix ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPBNmM.html" rel="bookmark" class="title">用Word查找替换从文档中分拣英文</a>
					<div>
						Word虽然很强大,但要智能识别出英文内容然后拣出来,貌似不行.但是俗话说,条条大路通罗马,咱换一个思路就可以解决这个问题了!那就是把文档中的所有中文删掉,剩下的不就是英文了吗? 这里要用到查找替换功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYjjBb.html" rel="bookmark" class="title">Win8&period;1鼠标延迟bug推出解决方案</a>
					<div>
						  不知道大家是否还记得之前我们曾为报道过有关微软Win8.1更新导致部分PC游戏遭遇严重的鼠标迟滞问题,以及为大家提供的解决方案.而日前微软也为这一问题给出了一些解决方案. 其实Win8.1上的鼠标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3dLBM.html" rel="bookmark" class="title">怎样打开Win8系统的DOS窗口</a>
					<div>
						对于电脑操作系统的发展,较为年轻的用户可能并不知道,没有图形界面的Dos系统曾经是最为流行的操作系统.不过Windows 7的到来,微软称结束了Dos时代.但其实哪怕到了Windows 8,Dos也还 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEB6kp.html" rel="bookmark" class="title">如点击一个放大事件，鼠标可以在地图上放大地图，怎么在地图上右键取消这个事件啊？</a>
					<div>
						问题描述 如点击一个放大事件,鼠标可以在地图上放大地图,怎么在地图上右键取消这个事件啊? public override void OnDblClick() { m_baseTool.OnDblCli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YAWRM.html" rel="bookmark" class="title">浏览器安全问题分析</a>
					<div>
						事端 – 安全漏洞穿透用户桌面 2009年2月,微软发布了广受关注的MS09-002安全漏洞公告,并随之马上提供了针对该漏洞的更新补丁.当访问者使用IE 7浏览器访问特定规格的网页时,MS09-002 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQRY5p.html" rel="bookmark" class="title">Ruby Fiber指南（三）过滤器</a>
					<div>
						Ruby Fiber指南(一)基础     Ruby Fiber指南(二)参数传递     Ruby Fiber指南(三)过滤器    Ruby Fiber指南(四)迭代器     Ruby Acto ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Pd14p.html" rel="bookmark" class="title">整合CPU&plus;GPU平台 AMD欲打造高智能生活</a>
					<div>
						作为知名处理器厂商,AMD一直致力于为人类打造更高性能的服务,AMD是目前业内唯一一个可以提供高性能CPU.高性能独立显卡GPU.主板芯片组三大组件的半导体公司. 为了在当今竞争异常激烈的市场中获得成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZExjYp.html" rel="bookmark" class="title">Alexa开通中文官方网站</a>
					<div>
						10月16日上午消息,网站流量排名提供商Alexa开通中文官方网站cn.alexa.com,目前只提供alexa.com上&quot;网站信息&quot;部分内容,其他内容正在不断添加中,这意味着Al ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NV9NM.html" rel="bookmark" class="title">403 ccess enied- 403Access Denied？？怎么改</a>
					<div>
						问题描述 403Access Denied??怎么改 我在myeclipse做了一个网站,然后输入http://127.0.0.1:8080/manager/login.jsp. 出现错误如下: Yo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJA712p.html" rel="bookmark" class="title">关于应用程序安装旧版本的问题</a>
					<div>
						问题描述 关于应用程序安装旧版本的问题 由于android不支持降级安装,现在由于需求需要安装旧版本,所以只能提示用户卸载当前程序,再下载旧版本程序,沿着这个思路大家有什么想法呢? 解决方案 linu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWl3gmp.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;供应链&rdquo;与&OpenCurlyDoubleQuote;信任&rdquo;：奢侈品电商前的两座大山</a>
					<div>
						&quot;寺库网目前只有三百多人,我们已经开始盈利了.&quot;6月末,寺库网CEO李日学在接受&lt;每日经济新闻&gt;记者独家专访时透露. 李日学坦言,&quot;供应链&quot;与&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDv4Kz.html" rel="bookmark" class="title">线程-同步代码块的问题。。。。。</a>
					<div>
						问题描述 同步代码块的问题..... 数据库的几张表常用表的数据,我想写到几个静态变量中. 然后提供若干个get方法,同时还有一个set方法重置所有的静态变量. 请问如何能够在set重置方法没完成以前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgZVoM.html" rel="bookmark" class="title">互联网史上一里程碑：美国计划移交互联网管理权</a>
					<div>
						美国政府机构14日宣布,计划把互联网域名系统等的管理权移交给&quot;全球利益攸关体&quot;.消息一出,美国舆论一片哗然.有人指出,这是朝着解决互联网管理纠纷正确方向迈出的一步,但相当多的人指责 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4ePQYb.html" rel="bookmark" class="title">谢安琪否认炫耀高学历斥责周刊挑拨离间&lpar;图&rpar;</a>
					<div>
						虽说被人&quot;编故事&quot;已习以为常,但这次无端被扭曲,谢安琪仍觉得很无辜 新浪娱乐讯 北京时间1月5日消息,据香港媒体报道,谢安琪和HotCha.邓咏芝等昨天出席保良局在机场富豪酒店举行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKj8np.html" rel="bookmark" class="title">洛阳地脉花最宜&comma;牡丹尤为天下奇</a>
					<div>
						洛阳地脉花最宜,牡丹尤为天下奇 www.zitian.cn 大家听说过武则天把牡丹贬到洛阳的故事吗? 女皇武则天下令百花同时开放,众花仙不敢抗命,唯牡丹仙子尊重时令,不听女皇圣旨,而被贬洛阳 从此,洛 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwY58M.html" rel="bookmark" class="title">jsp-什么时候需要加&dollar;&lbrace;pageContext&period;request&period;contextPath&rcub;？</a>
					<div>
						问题描述 什么时候需要加${pageContext.request.contextPath}? &lt;jsp:include page=&quot;/pages/pub/cardRead.jsp&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYX8Z5b.html" rel="bookmark" class="title">读《了解你的学生》有感</a>
					<div>
						一个刚入学的孩子心中所怀抱的学习图像,主要是来自他们所爱或信任的大人告诉他们学校是美好的,而不是因为他们相信学习本身所具有的价值.在刚开始的时候,孩子们会像大人们所希望的,快乐学习并用心学习.--摘自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkA3Pwb.html" rel="bookmark" class="title">Lucene5学习之Filter过滤器</a>
					<div>
						  清明3天假,我猜小伙伴们都相约出去玩去了,对于我等屌丝来说,唯有在家写代码打发时间了.其实不是我喜欢宅,只是一个人去哪儿都没有激情,还不如在家安安静静的看看书写写代码来的安逸,对这个看脸的世界就差 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1On0b.html" rel="bookmark" class="title">asp&period;net不用设置iis实现url重写 类似伪静态路由&lowbar;实用技巧</a>
					<div>
						程序要调整的部分只有两块.一是web.config文件.二是链接地址.所需urlrewrite.dll 首先下载URLRewriter:http://download.microsoft.com/do ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Q7l6p.html" rel="bookmark" class="title">MySQL Replication 主从配置的示例</a>
					<div>
						 mysql replication 主要通过复制二进制日志,在slave上执行master一样的来SQL来保持master 和slave的数据一致.     好处不必多说, 第一个 master-s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVe23z.html" rel="bookmark" class="title">photoshop设计烟雾形态紫色星空字效果制作教程</a>
					<div>
						给各位photoshop软件的使用者们来详细的解析分享一下设计烟雾形态紫色星空字效果的制作教程. 教程分享: 步骤1 创建一个1400px * 759px黑背景.把地面图像放到新建的文档中,选择透视调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ28o6z.html" rel="bookmark" class="title">动态表单中的值转换问题（Map）</a>
					<div>
						问题描述 publicStringadd()throwsException{Documentdocument=newDocument();document.setTitle(docInfo.getTi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWx0kz.html" rel="bookmark" class="title">在asp&period;net中使用vb&period;net绘图</a>
					<div>
						问题描述 在asp.net中使用vb.net绘图 asp.net中编程语言为vb.net,要绘图使用的是Graphics类,那么对于Graphics怎样初始化,定义为 dim gg as Graphi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGr43np.html" rel="bookmark" class="title">我的地方网站运营技巧和经验分享</a>
					<div>
						标题也许起的有点大了,其实也不是叫什么技巧和经验.都是我一年多了运营我这个http://www.aliyun.com/zixun/aggregation/8472.html&quot;&gt;地方网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7v4EM.html" rel="bookmark" class="title">快速识别重要威胁：威胁情报与SIEM的结合</a>
					<div>
						ThreatConnect是威胁情报代表性企业之一,著名的钻石模型理论提出者.ThreatConnect近期发布了一份报告,讲述企业如何通过威胁情报平台来增强SIEM/SOC的安全能力,以便更全面的理 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
